"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class Individual(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "id",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import opencb as opencb_1_3_0

        return {
            "samples": opencb_1_3_0.Sample,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_10 import opencb as opencb_1_3_0

        return {
            "org.opencb.biodata.models.metadata.Sample": opencb_1_3_0.Sample,
            "org.opencb.biodata.models.metadata.Individual": opencb_1_3_0.Individual,
        }

    __slots__ = [
        "id",
        "family",
        "father",
        "mother",
        "phenotype",
        "samples",
        "sex",
    ]

    def __init__(
        self,
        id,
        family=None,
        father=None,
        mother=None,
        phenotype=None,
        samples=list,
        sex=None,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_1_3_0.Individual model.

        :param id:
            Individual identifier
        :type id: str
        :param family:
        :type family: None | str
        :param father:
        :type father: None | str
        :param mother:
        :type mother: None | str
        :param phenotype:
        :type phenotype: None | str
        :param samples:
        :type samples: list[Sample]
        :param sex:
        :type sex: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.3.0"
